<?php
/*
Plugin Name: (rev) add_to_post
Description: Plugin to add content at the beginning and / or at the end of the posts.
Version: 1.0.1
Author: Eduardo Revilla Vaquero
Author URI: https://reviblog.net/
Text Domain: rev_add_to_post
Domain Path: /languages/
*/


if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

require_once('management.class.php');
require_once('funciones.class.php');

//creamos la clase 
if(!class_exists('AddToPost')):
class AddToPost{

	protected static $_instance = null;
	
	private $management;
	private $fun;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	// Evita que el objeto se pueda clonar
    public function __clone()
    {
        trigger_error('La clonación de este objeto no está permitida', E_USER_ERROR);
    }
    
    private function __construct() {
		
		$this->management = AddToPost_Management::instance();
		$this->fun = AddToPost_Funciones::instance();

		add_action( 'admin_init', array($this,'load_textdomain') ); // solo para la parte de admin.
		// add_action( 'plugins_loaded', array($this,'load_textdomain') ); // para la parte publica tambien
		
		add_action( 'admin_menu', array($this,'AddToPostManagementINIT') );

		add_filter( 'the_content', array($this,'filterAddToPost'), -1 );
		
		// hook cuando se activa el plugin.
		register_activation_hook(__FILE__,array($this,'ActivatePlugin'));		
		
    }
    
    // Se ejecuta al activar el plugin
    
    public function ActivatePlugin()
    {
	   // No necesitamos hacer nada
	}
    
    
    public function AddToPostManagementINIT()
    {		
		add_menu_page('Add to post', 'Add to post', 'level_5','add-to-post', array($this->management, 'addToPost'), plugins_url( 'images/ico.png', __FILE__ ));
	}

	public function filterAddToPost($content){
		return $this->fun->filterAddToPost($content);
	}

	public function load_textdomain() 
	{
  		load_plugin_textdomain( 'rev_add_to_post', FALSE, basename( dirname( __FILE__ ) ) . '/languages' );
	}
}
//creamos la instancia para poder utilizarlo 
$plugin_re_atp = AddToPost::instance();
endif;

?>
